#include "stdafx.h"
#include "wlan.h"

void showHelp()
{
	_tprintf(
		_T("Wireless LAN Profile Selector Console Version\n")
		_T("Ver.0.01, by Claybird<claybird.without.wing@gmail.com>\n")
		_T("Usage:wlpsel_con options|profile\n")
		_T("Options:\n")
		_T("  /list:        shows list of wifi profile(s)\n")
		_T("  /disconnect:  disconnects from wifi if connected\n")
		_T("  /help:        shows this help\n")
		_T("Profile:\n")
		_T("  connects to specified profile\n")
	);
}

int _tmain(int argc,TCHAR** argv)
{
	CWLan _wlan;
	//---get list of wifi profiles
	if(!_wlan.open()){
		_tprintf(_T("Failed to access wifi interface.\n"));
		return 1;
	}
	if(!_wlan.readGUID()){
		_tprintf(_T("Failed to access wifi interface.\n"));
		return 1;
	}
	if(!_wlan.readProfiles()){
		_tprintf(_T("Failed to read wifi profiles.\n"));
		return 2;
	}

	if(argc<=1){
		showHelp();
		return 0;
	}

	for(int i=1;i<argc;i++){
		if(_tcscmp(argv[i],_T("/list"))==0){
			//shows list of wifi profiles
			UINT numProfiles=_wlan.numProfiles();
			_tprintf(_T("Listing %d WiFi profile(s):\n"),numProfiles);
			for(UINT iProf=0;iProf<numProfiles;iProf++){
				_tprintf(_T("#%d:\t%s\n"),iProf+1,_wlan.getProfile(iProf).strProfileName);
			}
			return 0;
		}else if(_tcscmp(argv[i],_T("/help"))==0){
			//shows help
			showHelp();
			return 0;
		}else if(_tcscmp(argv[i],_T("/disconnect"))==0){
			_tprintf(_T("Disconnecting from wifi..."));
			if(_wlan.disconnect()){
				_tprintf(_T("done.\n"));
				return 0;
			}else{
				_tprintf(_T("FAILED.\n"));
				return 3;
			}
		}else{
			//connect to profile
			_tprintf(_T("Connecting to wifi..."));
			StdString strErr;
			if(_wlan.connect(argv[i],strErr)){
				_tprintf(_T("done.\n"));
				return 0;
			}else{
				_tprintf(_T("FAILED.\n"));
				_tprintf(_T("Reason:%s\n"),strErr.c_str());
				return 4;
			}
		}
	}
}
